#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <sys/utsname.h>
#include <string.h>
#include <fcntl.h>
#include <stdarg.h>

#include "tcpip.h"


char *getdomainname(struct sockaddr_in host)
{
  struct hostent *lookup;

  if ((lookup = gethostbyaddr((char *)&host.sin_addr,sizeof(long),AF_INET)) != NULL) 
    return((char *)lookup->h_name);

  return((char *)inet_ntoa(host.sin_addr));
}

#define OS_UNKNOWN 1
#define OS_BSD44 2
#define OS_LINUX 3
#define OS_WIN95 4

#define OSD_WIN95WAIT	0x0001

void checkos(struct sockaddr_in dest, short dport)
{
  spoofrec spoof;
  tcprec tcp;
  short done, start, type, flags=0;
  long timeout;

  start=(rand()%10000)+2048;
  spoof.seq=rand();
  spoof.ack=0;
  spoof.from.sin_addr=getlocalip(dest.sin_addr.s_addr);
  spoof.dest=dest;
  spoof.dport=dport;
  spoof.sport=start;

  /* First we'll check for Linux based systems */
  /*  When sent a FIN/SYN packet it replys with FIN/SYN/ACK */
  sendtcp(&spoof,CF_FIN | CF_SYN,NULL,0,1,1);

  spoof.sport=start+1;

  /* Then we'll check for 4.4 BSD based systems */
  /*  When sent a SYN/ACK it'll close the connection with the window !0 */
  sendtcp(&spoof,CF_SYN | CF_ACK,NULL,0,1,1);
 
  spoof.sport=start+2;

  /* Next we'll check for Win95 */
  /*  Will respond to FIN/SYN and to FIN */ 
  sendtcp(&spoof,CF_FIN,NULL,0,1,1);

  done=0;
  type=OS_UNKNOWN;
  timeout=time(NULL)+10;
  while ((timeout > time(NULL)) && (!done)) {
    if (gettcp(&spoof,&tcp)) {
      if (ntohs(tcp.sport) != dport)
        continue;

      if (ntohs(tcp.dport) == start) {
        if ((tcp.hrc & CF_SYN) && (tcp.hrc & CF_FIN)) {
          type=OS_LINUX;
          done=1;
        } else if (tcp.hrc & CF_SYN) {
          if (flags & OSD_WIN95WAIT) {
            done=1;
            type=OS_WIN95;
          } else 
            flags |= OSD_WIN95WAIT;
        }
      }
      if (ntohs(tcp.dport) == (start+1)) {
        if (tcp.window)  {
          type=OS_BSD44;
          done=1;
        }
      }
      if (ntohs(tcp.dport) == (start+2)) {
        if ((tcp.hrc & CF_ACK) && (tcp.hrc & CF_RST)) {
          if (flags & OSD_WIN95WAIT) {
            done=1;
            type=OS_WIN95;
          } else
            flags & OSD_WIN95WAIT;
        }
      }
    }
  }
  switch (type) {
    case OS_UNKNOWN:
      printf("Unknown Operating System\n");
      break;
    case OS_BSD44:
      printf("Operating System is based off of BSD 4.4\n");
      break;
    case OS_LINUX:
      printf("Operating System is Linux\n");
      break;
    case OS_WIN95:
      printf("Operating System is Windows 95/Windows NT\n");
      break;
  }
}

void main(int argc, char *argv[])
{
  struct sockaddr_in host,shost;
  unsigned short port;

  printf("Now checking...\n");
  init_tcpip();

  /* Unbuffer stdout and stdin */
  setvbuf(stdin,NULL,_IONBF,0);
  setvbuf(stdout,NULL,_IONBF,0);
  

        if (resolve_host(argv[1],&host)<0)
          exit(-1);
        
        printf("\nChecking Operating System of %s\n", getdomainname(host));
        printf("-------------------------------------------------------\n\n");
        printf("Checking via TCP flags: ");
        checkos(host, 23);
	
}
